/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "update_list.hh"
#include "src_update.hh"

using namespace sends;
using namespace std;

update_list sends::UpdateList;

//======================================  Update list constructor
update_list::update_list(void) {
}

//======================================  Update list destructor
update_list::~update_list(void) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	delete *i;
	*i = 0;
    }
}

//======================================  Update list destructor
void 
update_list::add(const src_update& su) {
    mVect.push_back(new src_update(su));
}

//======================================  Update list destructor
void 
update_list::start_all(void) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	(*i)->set_detached(true);
	(*i)->start();
    }
}

//======================================  Update list destructor
void 
update_list::stop_all(void) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	(*i)->stop();
    }
}

//======================================  Update list destructor
src_update* 
update_list::find(const std::string& suname) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	if ((*i)->name() == suname) return *i;
    }
    return 0;
}
